{{
  Karplus-Strong demo
}}

CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
  sr            = 44_100        ' let's run at the CD sampling rate
  sustain_value = 8
  demo_pinL     = 11
  demo_pinR     = 10

OBJ
  ks[2]         : "Karplus-Strong-1e"                      ' left channel information should be heard from your left speaker...
  term          : "FullDuplexSerial"

PUB test_KS | rn, p

  ' set up my serial port, and wait for the BST terminal to go live
  term.start( 31, 30, 0, 115_200 )

  ' set up using the demo board pins for the headphones
  ks[0].start( demo_pinL, -1, sr )
  ks[1].start( demo_pinR, -1, sr )

  waitcnt( clkfreq >> 3 + cnt )

  ks[0].set_sustain( 8 )
  ks[1].set_sustain( 8 )

  { Just play a note, stop the KS cog, then grab the buffer, then restart the cog
  ks[0].set_frequency( 1000 )
  ks[0].pluck( 255 )
  waitcnt( clkfreq >> 3 + cnt )
  ks[0].stop
  repeat p from 0 to constant( ks#buf_size - 1 )
    term.dec( p )
    term.tx( "," )
    term.dec( ks[0].dump_buf( p ) )
    term.tx( 10 )
  ks[0].start( demo_pinL, -1, sr )
  '}

  ' play the scale
  rn := 10
  repeat
    ' wait a bit
    waitcnt( clkfreq / 4 + cnt )

    ' set a note (MIDI spec), immediately updated, whether you pluck the string or not
    ks[0].set_note( rn )
    ks[1].set_note( rn + 4 )

    ' pluck both, at different time
    if (rn & %11) == 0
      ks[0].pluck( 255 )
    if (rn & %11) == 2
      ks[1].pluck( 255 )

    ' next note?
    ++rn
    rn //= 128

